function VP = vanish_points(points)

N = size(points, 1);
NL = N / 2;
w = 1;
for i = 2:2:N
    LNS(i/2, :) = cross([points(i-1, 1), points(i - 1, 2), w], [points(i, 1), points(i, 2), w]);
end

if (NL == 2)
    VP = cross(LNS(1, :), LNS(2, :));
    return;
end

M = zeros(3, 3);

for i = 1:NL
    M = M  + [  LNS(i, 1)^2, LNS(i, 1)*LNS(i,2), LNS(i, 3)*LNS(i, 1);
                LNS(i, 1)*LNS(i, 2), LNS(i,2)^2, LNS(i, 3)*LNS(i, 2);
                LNS(i, 1)*LNS(i, 3), LNS(i, 3)*LNS(i,2), LNS(i, 3)^2];
end

[U, S, V] = svd(M);
VP = V(:, size(V, 2));
VP = VP ./ VP(3)