function NM = apply_transform(transform, image)

[M, N, D] = size(image);
R = M*3;
C = N*3;
NMI = zeros(M, N, 2);
NM = zeros(R, C, 3);
c_minx = 999999999;
c_miny = 999999999;
c_maxx = -999999999;
c_maxy = -999999999;
tx = 0;
ty = 0;
T = transform*[round(N/2), round(M/2), 1]';
T = T ./ T(3);

for i = 1:M
    for j = 1:N
        X = [j - round(N/2), i - round(M/2), 1]';
        %X = [j, i,1]';
        x = transform*X;

        if (x(3) ~= 0)
            x = x ./ x(3);
        end
        
        NMI(i, j, 1) = x(2)+T(2);
        tx = tx + x(2);
        
        if (x(2) < c_minx)
            c_minx = x(2);
        end

        if (x(2) > c_maxx)
            c_maxx = x(2);
        end

        NMI(i, j, 2) = x(1)+T(2);
        ty = ty + x(1);
        
        if (x(1) < c_miny)
            c_miny = x(1);
        end
        if (x(1) > c_maxy)
            c_maxy = x(1);
        end
    end
end

c_minx
c_miny
c_maxx
c_maxy

% c_maxx = c_maxx - c_minx;
% c_maxy = c_maxy - c_miny;
% 
% xscale = M / c_maxx;
% yscale = N / c_maxy;
% 
% NMI(:, :, 1) =((NMI(:, :, 2) -c_minx ) .* xscale)+1;
% NMI(:, :, 2) =((NMI(:, :, 1) -c_miny ) .* yscale)+1;

ax = tx / (M*N);
ay = ty / (M*N);
% NMI(:, :, 1) =((NMI(:, :, 1) - c_minx) )+1;
% NMI(:, :, 2) =((NMI(:, :, 2) - c_miny) )+1;

% Railroad
NMI(:, :, 1) =((NMI(:, :, 1) + 0.75*R) )+1;
NMI(:, :, 2) =((NMI(:, :, 2) + C/3) )+1;

for i = 1:M
    for j = 1:N
        if ((NMI(i, j, 1) <= R) && (NMI(i, j, 2) <= C) && (NMI(i, j, 1) > 0) && (NMI(i, j, 2) > 0))
            NM(round(NMI(i, j, 1))+1, round(NMI(i, j, 2))+1, 1) = image(i, j, 1);
            NM(round(NMI(i, j, 1))+1, round(NMI(i, j, 2))+1, 2) = image(i, j, 2);
            NM(round(NMI(i, j, 1))+1, round(NMI(i, j, 2))+1, 3) = image(i, j, 3);
        end
    end
end
